<html>
<head>
<title>OgreAnimationTrack.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreAnimationTrack.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreAnimationTrack_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __AnimationTrack_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __AnimationTrack_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreSimpleSpline_8h.html">OgreSimpleSpline.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRotationalSpline_8h.html">OgreRotationalSpline.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreKeyFrame_8h.html">OgreKeyFrame.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreAnimable_8h.html">OgreAnimable.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgrePose_8h.html">OgrePose.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre 
<a name="l00040"></a>00040 {
<a name="l00049"></a><a class="code" href="classOgre_1_1TimeIndex.html">00049</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keyword">protected</span>:
<a name="l00054"></a><a class="code" href="classOgre_1_1TimeIndex.html#acd9dcf5973656fa8c015c2f0dfe1ce51">00054</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1TimeIndex.html#acd9dcf5973656fa8c015c2f0dfe1ce51" title="The time position (in relation to the whole animation sequence)">mTimePos</a>;
<a name="l00060"></a><a class="code" href="classOgre_1_1TimeIndex.html#a6b57e79eff73506c3ec46c9847a86d22">00060</a>         <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="classOgre_1_1TimeIndex.html#a6b57e79eff73506c3ec46c9847a86d22" title="The global keyframe index (in relation to the whole animation sequence) that used to convert to local...">mKeyIndex</a>;
<a name="l00061"></a>00061 
<a name="l00064"></a><a class="code" href="classOgre_1_1TimeIndex.html#a6925dd1b6e2a897eb4ddc3d6a56af40d">00064</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> INVALID_KEY_INDEX = (<a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>)-1;
<a name="l00065"></a>00065 
<a name="l00066"></a>00066     <span class="keyword">public</span>:
<a name="l00069"></a><a class="code" href="classOgre_1_1TimeIndex.html#adc00e0190b54c72be2185ce650daa7a7">00069</a>         <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos)
<a name="l00070"></a>00070             : mTimePos(timePos)
<a name="l00071"></a>00071             , mKeyIndex(INVALID_KEY_INDEX)
<a name="l00072"></a>00072         {
<a name="l00073"></a>00073         }
<a name="l00074"></a>00074 
<a name="l00080"></a><a class="code" href="classOgre_1_1TimeIndex.html#ac6f0421e5a3c653ce5e5a1a6383e969f">00080</a>         <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> keyIndex)
<a name="l00081"></a>00081             : mTimePos(timePos)
<a name="l00082"></a>00082             , mKeyIndex(keyIndex)
<a name="l00083"></a>00083         {
<a name="l00084"></a>00084         }
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classOgre_1_1TimeIndex.html#a69db72c39f34b6257d5a456922fc69f8">00086</a>         <span class="keywordtype">bool</span> hasKeyIndex(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00087"></a>00087 <span class="keyword">        </span>{
<a name="l00088"></a>00088             <span class="keywordflow">return</span> mKeyIndex != INVALID_KEY_INDEX;
<a name="l00089"></a>00089         }
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classOgre_1_1TimeIndex.html#a9890d671f480025a787d519e4a922184">00091</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getTimePos(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00092"></a>00092 <span class="keyword">        </span>{
<a name="l00093"></a>00093             <span class="keywordflow">return</span> mTimePos;
<a name="l00094"></a>00094         }
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classOgre_1_1TimeIndex.html#a2a97453fc7d6ce7e25a64de23114f786">00096</a>         <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> getKeyIndex(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00097"></a>00097 <span class="keyword">        </span>{
<a name="l00098"></a>00098             <span class="keywordflow">return</span> mKeyIndex;
<a name="l00099"></a>00099         }
<a name="l00100"></a>00100     };
<a name="l00101"></a>00101 
<a name="l00121"></a><a class="code" href="classOgre_1_1AnimationTrack.html">00121</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AnimationAlloc</a>
<a name="l00122"></a>00122     {
<a name="l00123"></a>00123     <span class="keyword">public</span>:
<a name="l00124"></a>00124 
<a name="l00128"></a><a class="code" href="classOgre_1_1AnimationTrack_1_1Listener.html">00128</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AnimationTrack_1_1Listener.html" title="Listener allowing you to override certain behaviour of a track, for example to drive animation proced...">Listener</a>
<a name="l00129"></a>00129         {
<a name="l00130"></a>00130         <span class="keyword">public</span>:
<a name="l00131"></a><a class="code" href="classOgre_1_1AnimationTrack_1_1Listener.html#a9a91170a7c4f2cf343ccf402ba83127f">00131</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1AnimationTrack_1_1Listener.html#a9a91170a7c4f2cf343ccf402ba83127f">~Listener</a>() {}
<a name="l00132"></a>00132 
<a name="l00136"></a>00136             <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getInterpolatedKeyFrame(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* t, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* kf) = 0;
<a name="l00137"></a>00137         };
<a name="l00138"></a>00138 
<a name="l00140"></a>00140         <a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>(<a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* parent, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>();
<a name="l00143"></a>00143 
<a name="l00145"></a><a class="code" href="classOgre_1_1AnimationTrack.html#a32de796f12f6afee4c93e12625535577">00145</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1AnimationTrack.html#a32de796f12f6afee4c93e12625535577" title="Get the handle associated with this track.">getHandle</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHandle; }
<a name="l00146"></a>00146 
<a name="l00148"></a>00148         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumKeyFrames(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00149"></a>00149 
<a name="l00151"></a>00151         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* getKeyFrame(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00152"></a>00152 
<a name="l00174"></a>00174         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getKeyFramesAtTime(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>** keyFrame1, <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>** keyFrame2,
<a name="l00175"></a>00175             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span>* firstKeyIndex = 0) <span class="keyword">const</span>;
<a name="l00176"></a>00176 
<a name="l00184"></a>00184         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* createKeyFrame(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos);
<a name="l00185"></a>00185 
<a name="l00187"></a>00187         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeKeyFrame(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00188"></a>00188 
<a name="l00190"></a>00190         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAllKeyFrames(<span class="keywordtype">void</span>);
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00202"></a>00202         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getInterpolatedKeyFrame(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* kf) <span class="keyword">const</span> = 0;
<a name="l00203"></a>00203 
<a name="l00211"></a>00211         <span class="keyword">virtual</span> <span class="keywordtype">void</span> apply(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f) = 0;
<a name="l00212"></a>00212 
<a name="l00215"></a><a class="code" href="classOgre_1_1AnimationTrack.html#a715b6d025247c4857a5deba9376ae48c">00215</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimationTrack.html#a715b6d025247c4857a5deba9376ae48c" title="Internal method used to tell the track that keyframe data has been changed, which may cause it to reb...">_keyFrameDataChanged</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{}
<a name="l00216"></a>00216 
<a name="l00221"></a><a class="code" href="classOgre_1_1AnimationTrack.html#a3a07b2082c15608cc24be21e2b6bb822">00221</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1AnimationTrack.html#a3a07b2082c15608cc24be21e2b6bb822" title="Method to determine if this track has any KeyFrames which are doing anything useful - can be used to ...">hasNonZeroKeyFrames</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00222"></a>00222 
<a name="l00224"></a><a class="code" href="classOgre_1_1AnimationTrack.html#ad96281be1b189c69a1dbd2283d583503">00224</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimationTrack.html#ad96281be1b189c69a1dbd2283d583503" title="Optimise the current track by removing any duplicate keyframes.">optimise</a>(<span class="keywordtype">void</span>) {}
<a name="l00225"></a>00225 
<a name="l00227"></a>00227         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _collectKeyFrameTimes(<a class="code" href="structOgre_1_1vector.html">vector&lt;Real&gt;::type</a>&amp; keyFrameTimes);
<a name="l00228"></a>00228 
<a name="l00231"></a>00231         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _buildKeyFrameIndexMap(<span class="keyword">const</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Real&gt;::type</a>&amp; keyFrameTimes);
<a name="l00232"></a>00232         
<a name="l00234"></a><a class="code" href="classOgre_1_1AnimationTrack.html#aed855e8117300af01d646ff49b020916">00234</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimationTrack.html#aed855e8117300af01d646ff49b020916" title="Internal method to re-base the keyframes relative to a given keyframe.">_applyBaseKeyFrame</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* base) {}
<a name="l00235"></a>00235 
<a name="l00237"></a><a class="code" href="classOgre_1_1AnimationTrack.html#afe26aa738aca34c07407b6566b5d9eeb">00237</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimationTrack.html#afe26aa738aca34c07407b6566b5d9eeb" title="Set a listener for this track.">setListener</a>(<a class="code" href="classOgre_1_1AnimationTrack_1_1Listener.html" title="Listener allowing you to override certain behaviour of a track, for example to drive animation proced...">Listener</a>* l) { mListener = l; }
<a name="l00238"></a>00238 
<a name="l00240"></a><a class="code" href="classOgre_1_1AnimationTrack.html#a2e5269293886cae1d0bc7e0255b239fd">00240</a>         <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a> *<a class="code" href="classOgre_1_1AnimationTrack.html#a2e5269293886cae1d0bc7e0255b239fd" title="Returns the parent Animation object for this track.">getParent</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mParent; }
<a name="l00241"></a>00241     <span class="keyword">protected</span>:
<a name="l00242"></a><a class="code" href="classOgre_1_1AnimationTrack.html#affbdca5aaf89d6d611d8da2dc6143f1a">00242</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;KeyFrame*&gt;::type</a> <a class="code" href="classOgre_1_1AnimationTrack.html#affbdca5aaf89d6d611d8da2dc6143f1a">KeyFrameList</a>;
<a name="l00243"></a><a class="code" href="classOgre_1_1AnimationTrack.html#a8a9bee08f6fa537fc0bcfcee2423775c">00243</a>         <a class="code" href="classOgre_1_1AnimationTrack.html#affbdca5aaf89d6d611d8da2dc6143f1a">KeyFrameList</a> <a class="code" href="classOgre_1_1AnimationTrack.html#a8a9bee08f6fa537fc0bcfcee2423775c">mKeyFrames</a>;
<a name="l00244"></a><a class="code" href="classOgre_1_1AnimationTrack.html#aea479089005d263e195cde7e4faca665">00244</a>         <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* <a class="code" href="classOgre_1_1AnimationTrack.html#aea479089005d263e195cde7e4faca665">mParent</a>;
<a name="l00245"></a><a class="code" href="classOgre_1_1AnimationTrack.html#a5fb5dc3c01452aa4d542981485d15080">00245</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1AnimationTrack.html#a5fb5dc3c01452aa4d542981485d15080">mHandle</a>;
<a name="l00246"></a><a class="code" href="classOgre_1_1AnimationTrack.html#ab1a098b88d428931e3d45393410bc68c">00246</a>         <a class="code" href="classOgre_1_1AnimationTrack_1_1Listener.html" title="Listener allowing you to override certain behaviour of a track, for example to drive animation proced...">Listener</a>* <a class="code" href="classOgre_1_1AnimationTrack.html#ab1a098b88d428931e3d45393410bc68c">mListener</a>;
<a name="l00247"></a>00247 
<a name="l00249"></a><a class="code" href="classOgre_1_1AnimationTrack.html#a2faf6bb4a4d61446bc25795f8f7d957c">00249</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ushort&gt;::type</a> <a class="code" href="classOgre_1_1AnimationTrack.html#a2faf6bb4a4d61446bc25795f8f7d957c" title="Map used to translate global keyframe time lower bound index to local lower bound index...">KeyFrameIndexMap</a>;
<a name="l00250"></a><a class="code" href="classOgre_1_1AnimationTrack.html#a2c053bac1d2eedc782eb24b79dc79a21">00250</a>         <a class="code" href="classOgre_1_1AnimationTrack.html#a2faf6bb4a4d61446bc25795f8f7d957c" title="Map used to translate global keyframe time lower bound index to local lower bound index...">KeyFrameIndexMap</a> <a class="code" href="classOgre_1_1AnimationTrack.html#a2c053bac1d2eedc782eb24b79dc79a21">mKeyFrameIndexMap</a>;
<a name="l00251"></a>00251 
<a name="l00253"></a>00253         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* createKeyFrameImpl(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> time) = 0;
<a name="l00254"></a>00254 
<a name="l00256"></a>00256         <span class="keyword">virtual</span> <span class="keywordtype">void</span> populateClone(<a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>* clone) <span class="keyword">const</span>;
<a name="l00257"></a>00257         
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260     };
<a name="l00261"></a>00261 
<a name="l00264"></a><a class="code" href="classOgre_1_1NumericAnimationTrack.html">00264</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1NumericAnimationTrack.html" title="Specialised AnimationTrack for dealing with generic animable values.">NumericAnimationTrack</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>
<a name="l00265"></a>00265     {
<a name="l00266"></a>00266     <span class="keyword">public</span>:
<a name="l00268"></a>00268         <a class="code" href="classOgre_1_1NumericAnimationTrack.html" title="Specialised AnimationTrack for dealing with generic animable values.">NumericAnimationTrack</a>(<a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* parent, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00270"></a>00270         <a class="code" href="classOgre_1_1NumericAnimationTrack.html" title="Specialised AnimationTrack for dealing with generic animable values.">NumericAnimationTrack</a>(<a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* parent, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle, 
<a name="l00271"></a>00271             <a class="code" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a>&amp; target);
<a name="l00272"></a>00272 
<a name="l00280"></a>00280         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1NumericKeyFrame.html" title="Specialised KeyFrame which stores any numeric value.">NumericKeyFrame</a>* createNumericKeyFrame(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos);
<a name="l00281"></a>00281 
<a name="l00283"></a>00283         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getInterpolatedKeyFrame(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* kf) <span class="keyword">const</span>;
<a name="l00284"></a>00284 
<a name="l00286"></a>00286         <span class="keyword">virtual</span> <span class="keywordtype">void</span> apply(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00287"></a>00287 
<a name="l00296"></a>00296         <span class="keywordtype">void</span> applyToAnimable(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a>&amp; anim, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, 
<a name="l00297"></a>00297             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00298"></a>00298 
<a name="l00300"></a>00300         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a>&amp; getAssociatedAnimable(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00301"></a>00301 
<a name="l00304"></a>00304         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAssociatedAnimable(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a>&amp; val);
<a name="l00305"></a>00305 
<a name="l00307"></a>00307         <a class="code" href="classOgre_1_1NumericKeyFrame.html" title="Specialised KeyFrame which stores any numeric value.">NumericKeyFrame</a>* getNumericKeyFrame(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00308"></a>00308 
<a name="l00310"></a>00310         <a class="code" href="classOgre_1_1NumericAnimationTrack.html" title="Specialised AnimationTrack for dealing with generic animable values.">NumericAnimationTrack</a>* _clone(<a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* newParent) <span class="keyword">const</span>;
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313     <span class="keyword">protected</span>:
<a name="l00315"></a><a class="code" href="classOgre_1_1NumericAnimationTrack.html#a9abd089b3278141471254455f45c648d">00315</a>         <a class="code" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a> <a class="code" href="classOgre_1_1NumericAnimationTrack.html#a9abd089b3278141471254455f45c648d" title="Target to animate.">mTargetAnim</a>;
<a name="l00316"></a>00316 
<a name="l00318"></a>00318         <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* createKeyFrameImpl(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> time);
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 
<a name="l00321"></a>00321     };
<a name="l00322"></a>00322 
<a name="l00325"></a><a class="code" href="classOgre_1_1NodeAnimationTrack.html">00325</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>
<a name="l00326"></a>00326     {
<a name="l00327"></a>00327     <span class="keyword">public</span>:
<a name="l00329"></a>00329         <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>(<a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* parent, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00331"></a>00331         <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>(<a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* parent, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle, 
<a name="l00332"></a>00332             <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* targetNode);
<a name="l00334"></a>00334         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>();
<a name="l00342"></a>00342         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1TransformKeyFrame.html" title="Specialised KeyFrame which stores a full transform.">TransformKeyFrame</a>* createNodeKeyFrame(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos);
<a name="l00344"></a>00344         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* getAssociatedNode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00345"></a>00345 
<a name="l00347"></a>00347         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAssociatedNode(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* node);
<a name="l00348"></a>00348 
<a name="l00350"></a>00350         <span class="keyword">virtual</span> <span class="keywordtype">void</span> applyToNode(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* node, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, 
<a name="l00351"></a>00351             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00352"></a>00352 
<a name="l00354"></a>00354         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setUseShortestRotationPath(<span class="keywordtype">bool</span> useShortestPath);
<a name="l00355"></a>00355 
<a name="l00357"></a>00357         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getUseShortestRotationPath() <span class="keyword">const</span>;
<a name="l00358"></a>00358 
<a name="l00360"></a>00360         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getInterpolatedKeyFrame(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* kf) <span class="keyword">const</span>;
<a name="l00361"></a>00361 
<a name="l00363"></a>00363         <span class="keyword">virtual</span> <span class="keywordtype">void</span> apply(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00364"></a>00364 
<a name="l00366"></a>00366         <span class="keywordtype">void</span> _keyFrameDataChanged(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00367"></a>00367 
<a name="l00369"></a>00369         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1TransformKeyFrame.html" title="Specialised KeyFrame which stores a full transform.">TransformKeyFrame</a>* getNodeKeyFrame(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00376"></a>00376         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasNonZeroKeyFrames(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00377"></a>00377 
<a name="l00379"></a>00379         <span class="keyword">virtual</span> <span class="keywordtype">void</span> optimise(<span class="keywordtype">void</span>);
<a name="l00380"></a>00380 
<a name="l00382"></a>00382         <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>* _clone(<a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* newParent) <span class="keyword">const</span>;
<a name="l00383"></a>00383         
<a name="l00384"></a>00384         <span class="keywordtype">void</span> _applyBaseKeyFrame(<span class="keyword">const</span> <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* base);
<a name="l00385"></a>00385         
<a name="l00386"></a>00386     <span class="keyword">protected</span>:
<a name="l00388"></a>00388         <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* createKeyFrameImpl(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> time);
<a name="l00389"></a>00389         <span class="comment">// Flag indicating we need to rebuild the splines next time</span>
<a name="l00390"></a>00390         <span class="keyword">virtual</span> <span class="keywordtype">void</span> buildInterpolationSplines(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00391"></a>00391 
<a name="l00392"></a>00392         <span class="comment">// Struct for store splines, allocate on demand for better memory footprint</span>
<a name="l00393"></a><a class="code" href="structOgre_1_1NodeAnimationTrack_1_1Splines.html">00393</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1NodeAnimationTrack_1_1Splines.html">Splines</a>
<a name="l00394"></a>00394         {
<a name="l00395"></a><a class="code" href="structOgre_1_1NodeAnimationTrack_1_1Splines.html#a545a2f4873eb3e6ff42997da321cbe59">00395</a>             <a class="code" href="classOgre_1_1SimpleSpline.html" title="A very simple spline class which implements the Catmull-Rom class of splines.">SimpleSpline</a> <a class="code" href="structOgre_1_1NodeAnimationTrack_1_1Splines.html#a545a2f4873eb3e6ff42997da321cbe59">positionSpline</a>;
<a name="l00396"></a><a class="code" href="structOgre_1_1NodeAnimationTrack_1_1Splines.html#af7740aeef144596bb9eab92e0aefab3a">00396</a>             <a class="code" href="classOgre_1_1SimpleSpline.html" title="A very simple spline class which implements the Catmull-Rom class of splines.">SimpleSpline</a> <a class="code" href="structOgre_1_1NodeAnimationTrack_1_1Splines.html#af7740aeef144596bb9eab92e0aefab3a">scaleSpline</a>;
<a name="l00397"></a><a class="code" href="structOgre_1_1NodeAnimationTrack_1_1Splines.html#a4b17f183d68c44f65eb9ff11b61b90fc">00397</a>             <a class="code" href="classOgre_1_1RotationalSpline.html" title="This class interpolates orientations (rotations) along a spline using derivatives of quaternions...">RotationalSpline</a> <a class="code" href="structOgre_1_1NodeAnimationTrack_1_1Splines.html#a4b17f183d68c44f65eb9ff11b61b90fc">rotationSpline</a>;
<a name="l00398"></a>00398         };
<a name="l00399"></a>00399 
<a name="l00400"></a><a class="code" href="classOgre_1_1NodeAnimationTrack.html#a0dc80f6d98b2b0d4d1022af4629abf88">00400</a>         <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* <a class="code" href="classOgre_1_1NodeAnimationTrack.html#a0dc80f6d98b2b0d4d1022af4629abf88">mTargetNode</a>;
<a name="l00401"></a>00401         <span class="comment">// Prebuilt splines, must be mutable since lazy-update in const method</span>
<a name="l00402"></a><a class="code" href="classOgre_1_1NodeAnimationTrack.html#aeda31d3b9e77688be33d7e57b0d25f0b">00402</a>         <span class="keyword">mutable</span> <a class="code" href="structOgre_1_1NodeAnimationTrack_1_1Splines.html">Splines</a>* <a class="code" href="classOgre_1_1NodeAnimationTrack.html#aeda31d3b9e77688be33d7e57b0d25f0b">mSplines</a>;
<a name="l00403"></a><a class="code" href="classOgre_1_1NodeAnimationTrack.html#a9254f84e8a884379be88508481a9760d">00403</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1NodeAnimationTrack.html#a9254f84e8a884379be88508481a9760d">mSplineBuildNeeded</a>;
<a name="l00405"></a><a class="code" href="classOgre_1_1NodeAnimationTrack.html#a5b92dd90793e598d1338e0573a22d62d">00405</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1NodeAnimationTrack.html#a5b92dd90793e598d1338e0573a22d62d" title="Defines if rotation is done using shortest path.">mUseShortestRotationPath</a> ;
<a name="l00406"></a>00406     };
<a name="l00407"></a>00407 
<a name="l00466"></a><a class="code" href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e">00466</a>     <span class="keyword">enum</span> <a class="code" href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a>
<a name="l00467"></a>00467     {
<a name="l00469"></a><a class="code" href="group__Animation.html#gga9046e6e0d12c46c57a9056987e9d158eab1a15dd49cf588c9b4d29e96511dc91a">00469</a>         <a class="code" href="group__Animation.html#gga9046e6e0d12c46c57a9056987e9d158eab1a15dd49cf588c9b4d29e96511dc91a" title="No animation.">VAT_NONE</a> = 0,
<a name="l00471"></a><a class="code" href="group__Animation.html#gga9046e6e0d12c46c57a9056987e9d158ea16f039e4ae5cfb19ecd7cd41be4f93cd">00471</a>         <a class="code" href="group__Animation.html#gga9046e6e0d12c46c57a9056987e9d158ea16f039e4ae5cfb19ecd7cd41be4f93cd" title="Morph animation is made up of many interpolated snapshot keyframes.">VAT_MORPH</a> = 1,
<a name="l00473"></a><a class="code" href="group__Animation.html#gga9046e6e0d12c46c57a9056987e9d158ea66715a5b810eee81efa1d964700b3d30">00473</a>         <a class="code" href="group__Animation.html#gga9046e6e0d12c46c57a9056987e9d158ea66715a5b810eee81efa1d964700b3d30" title="Pose animation is made up of a single delta pose keyframe.">VAT_POSE</a> = 2
<a name="l00474"></a>00474     };
<a name="l00475"></a>00475 
<a name="l00479"></a><a class="code" href="classOgre_1_1VertexAnimationTrack.html">00479</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1VertexAnimationTrack.html" title="Specialised AnimationTrack for dealing with changing vertex position information.">VertexAnimationTrack</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>
<a name="l00480"></a>00480     {
<a name="l00481"></a>00481     <span class="keyword">public</span>:
<a name="l00483"></a><a class="code" href="classOgre_1_1VertexAnimationTrack.html#a8428fcdefb79b2dd650b22968a3e8134">00483</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1VertexAnimationTrack.html#a8428fcdefb79b2dd650b22968a3e8134" title="The target animation mode.">TargetMode</a>
<a name="l00484"></a>00484         {
<a name="l00486"></a><a class="code" href="classOgre_1_1VertexAnimationTrack.html#a8428fcdefb79b2dd650b22968a3e8134a2e9398cdf64d0a07033f83a3ddaadf2c">00486</a>             <a class="code" href="classOgre_1_1VertexAnimationTrack.html#a8428fcdefb79b2dd650b22968a3e8134a2e9398cdf64d0a07033f83a3ddaadf2c" title="Interpolate vertex positions in software.">TM_SOFTWARE</a>, 
<a name="l00489"></a><a class="code" href="classOgre_1_1VertexAnimationTrack.html#a8428fcdefb79b2dd650b22968a3e8134a8c5fb4696cb266eb28aa2ec029aad0c3">00489</a>             TM_HARDWARE
<a name="l00490"></a>00490         };
<a name="l00492"></a>00492         <a class="code" href="classOgre_1_1VertexAnimationTrack.html" title="Specialised AnimationTrack for dealing with changing vertex position information.">VertexAnimationTrack</a>(<a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* parent, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle, <a class="code" href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> animType);
<a name="l00494"></a>00494         <a class="code" href="classOgre_1_1VertexAnimationTrack.html" title="Specialised AnimationTrack for dealing with changing vertex position information.">VertexAnimationTrack</a>(<a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* parent, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle, <a class="code" href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> animType, 
<a name="l00495"></a>00495             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* targetData, TargetMode target = TM_SOFTWARE);
<a name="l00496"></a>00496 
<a name="l00498"></a><a class="code" href="classOgre_1_1VertexAnimationTrack.html#aa2c105e1ad534cdd9938331f8eb1cae6">00498</a>         <a class="code" href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> <a class="code" href="classOgre_1_1VertexAnimationTrack.html#aa2c105e1ad534cdd9938331f8eb1cae6" title="Get the type of vertex animation we&#39;re performing.">getAnimationType</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAnimationType; }
<a name="l00499"></a>00499         
<a name="l00501"></a>00501         <span class="keywordtype">bool</span> getVertexAnimationIncludesNormals() <span class="keyword">const</span>;
<a name="l00502"></a>00502 
<a name="l00510"></a>00510         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1VertexMorphKeyFrame.html" title="Specialised KeyFrame which stores absolute vertex positions for a complete buffer, designed to be interpolated with other keys in the same track.">VertexMorphKeyFrame</a>* createVertexMorphKeyFrame(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos);
<a name="l00511"></a>00511 
<a name="l00514"></a>00514         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1VertexPoseKeyFrame.html" title="Specialised KeyFrame which references a Mesh::Pose at a certain influence level, which stores offsets...">VertexPoseKeyFrame</a>* createVertexPoseKeyFrame(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos);
<a name="l00515"></a>00515 
<a name="l00518"></a>00518         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getInterpolatedKeyFrame(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* kf) <span class="keyword">const</span>;
<a name="l00519"></a>00519 
<a name="l00521"></a>00521         <span class="keyword">virtual</span> <span class="keywordtype">void</span> apply(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00522"></a>00522 
<a name="l00525"></a>00525         <span class="keyword">virtual</span> <span class="keywordtype">void</span> applyToVertexData(<a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* data, 
<a name="l00526"></a>00526             <span class="keyword">const</span> <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a>&amp; timeIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, 
<a name="l00527"></a>00527             <span class="keyword">const</span> <a class="code" href="group__Animation.html#ga2320179c7d0107995d8a737c86a40333">PoseList</a>* poseList = 0);
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00531"></a>00531         <a class="code" href="classOgre_1_1VertexMorphKeyFrame.html" title="Specialised KeyFrame which stores absolute vertex positions for a complete buffer, designed to be interpolated with other keys in the same track.">VertexMorphKeyFrame</a>* getVertexMorphKeyFrame(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00532"></a>00532 
<a name="l00534"></a>00534         <a class="code" href="classOgre_1_1VertexPoseKeyFrame.html" title="Specialised KeyFrame which references a Mesh::Pose at a certain influence level, which stores offsets...">VertexPoseKeyFrame</a>* getVertexPoseKeyFrame(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00535"></a>00535 
<a name="l00537"></a><a class="code" href="classOgre_1_1VertexAnimationTrack.html#aa37cffa57bfec055af3982f6c50c45a9">00537</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1VertexAnimationTrack.html#aa37cffa57bfec055af3982f6c50c45a9" title="Sets the associated VertexData which this track will update.">setAssociatedVertexData</a>(<a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* data) { mTargetVertexData = data; }
<a name="l00539"></a><a class="code" href="classOgre_1_1VertexAnimationTrack.html#aa1c92109ea295276cb6730ba8f155a64">00539</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* <a class="code" href="classOgre_1_1VertexAnimationTrack.html#aa1c92109ea295276cb6730ba8f155a64" title="Gets the associated VertexData which this track will update.">getAssociatedVertexData</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTargetVertexData; }
<a name="l00540"></a>00540 
<a name="l00542"></a><a class="code" href="classOgre_1_1VertexAnimationTrack.html#ad3def6ebcacc946484a16745ba89a060">00542</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1VertexAnimationTrack.html#ad3def6ebcacc946484a16745ba89a060" title="Set the target mode.">setTargetMode</a>(<a class="code" href="classOgre_1_1VertexAnimationTrack.html#a8428fcdefb79b2dd650b22968a3e8134" title="The target animation mode.">TargetMode</a> m) { mTargetMode = m; }
<a name="l00544"></a><a class="code" href="classOgre_1_1VertexAnimationTrack.html#a9ba2ac9172215ae3abfdf2cda61da663">00544</a>         <a class="code" href="classOgre_1_1VertexAnimationTrack.html#a8428fcdefb79b2dd650b22968a3e8134" title="The target animation mode.">TargetMode</a> <a class="code" href="classOgre_1_1VertexAnimationTrack.html#a9ba2ac9172215ae3abfdf2cda61da663" title="Get the target mode.">getTargetMode</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTargetMode; }
<a name="l00545"></a>00545 
<a name="l00550"></a>00550         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasNonZeroKeyFrames(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00551"></a>00551 
<a name="l00553"></a>00553         <span class="keyword">virtual</span> <span class="keywordtype">void</span> optimise(<span class="keywordtype">void</span>);
<a name="l00554"></a>00554 
<a name="l00556"></a>00556         <a class="code" href="classOgre_1_1VertexAnimationTrack.html" title="Specialised AnimationTrack for dealing with changing vertex position information.">VertexAnimationTrack</a>* _clone(<a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* newParent) <span class="keyword">const</span>;
<a name="l00557"></a>00557         
<a name="l00558"></a>00558         <span class="keywordtype">void</span> _applyBaseKeyFrame(<span class="keyword">const</span> <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* base);
<a name="l00559"></a>00559 
<a name="l00560"></a>00560     <span class="keyword">protected</span>:
<a name="l00562"></a><a class="code" href="classOgre_1_1VertexAnimationTrack.html#a2ac916da1e92895527b816f1da170759">00562</a>         <a class="code" href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> <a class="code" href="classOgre_1_1VertexAnimationTrack.html#a2ac916da1e92895527b816f1da170759" title="Animation type.">mAnimationType</a>;
<a name="l00564"></a><a class="code" href="classOgre_1_1VertexAnimationTrack.html#a146021bbee13fee93a93bd8ef913d77a">00564</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* <a class="code" href="classOgre_1_1VertexAnimationTrack.html#a146021bbee13fee93a93bd8ef913d77a" title="Target to animate.">mTargetVertexData</a>;
<a name="l00566"></a><a class="code" href="classOgre_1_1VertexAnimationTrack.html#a719e33971eaf3ae6b4f9bc603c94595c">00566</a>         <a class="code" href="classOgre_1_1VertexAnimationTrack.html#a8428fcdefb79b2dd650b22968a3e8134" title="The target animation mode.">TargetMode</a> <a class="code" href="classOgre_1_1VertexAnimationTrack.html#a719e33971eaf3ae6b4f9bc603c94595c" title="Mode to apply.">mTargetMode</a>;
<a name="l00567"></a>00567 
<a name="l00569"></a>00569         <a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>* createKeyFrameImpl(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> time);
<a name="l00570"></a>00570 
<a name="l00572"></a>00572         <span class="keywordtype">void</span> applyPoseToVertexData(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>* pose, <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* data, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> influence);
<a name="l00573"></a>00573 
<a name="l00574"></a>00574 
<a name="l00575"></a>00575     };
<a name="l00578"></a>00578 }
<a name="l00579"></a>00579 
<a name="l00580"></a>00580 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
